//: C07:VectorCoreDump.cpp
// Z knihy "Myslíme v jazyce C++, část 2" od Bruce Eckela a Chucka Allisona.
// (c) 1995-2004 MindView, Inc. Všechna práva vyhrazena.
// Přečtěte si podmínky používání zdrojových kódů umístěné v souboru 
// 'Licence.txt' dodávaném spolu s balíčkem kódu dostupným na www.MindView.net.
// Zneplatnění iterátoru.
#include <iterator>
#include <iostream>
#include <vector>
using namespace std;

int main() {
  vector<int> vi(10, 0);
  ostream_iterator<int> vystup(cout, " ");
  vector<int>::iterator i = vi.begin();
  *i = 47;
  copy(vi.begin(), vi.end(), vystup);
  cout << endl;
  // Vynutit přesun paměti 
	//(také by šlo pouze přidat dost objektů):
  vi.resize(vi.capacity() + 1);
  // Nyní ukazuje i na neplatnou paměť:
  *i = 48;  // Narušení přístupu
  copy(vi.begin(), vi.end(), vystup); // Žádná změna na vi[0]
} ///:~
